#debuginfo not supported with Go
%global debug_package %{nil}

%global package_name openshift-gitops-kam
%global product_name OpenShift GitOps KAM
%global golang_version 1.15
%global kam_version 1.8.3
%global kam_release  6
%global commitid 570cc72bc93f1cf3cf50453b73d96f9aa7ef6a6b
%global source_dir kam-%{commitid}
%global source_tar kam-570cc72bc93f1cf3cf50453b73d96f9aa7ef6a6b.tar.gz

Name:           %{package_name}
Version:        %{kam_version}
Release:        %{kam_release}%{?dist}
Summary:        %{product_name} OpenShift GitOps Kubernetes Application Manager CLI tool 
License:        ASL 2.0
URL:            https://github.com/redhat-developer/kam/commit/%{commitid}

Source0:        %{source_tar}
BuildRequires:  golang >= %{golang_version}
Provides:       %{package_name}
Obsoletes:      %{package_name}

%description
%{summary}

%package redistributable
Summary:        %{product_name} kam binaries for Linux, Mac OSX, and Windows
BuildRequires:  golang >= %{golang_version}
Provides:       %{package_name}-redistributable
Obsoletes:      %{package_name}-redistributable

Provides:       bundled golang(github.com/bitnami-labs/sealed-secrets/pkg/apis/sealed-secrets/v1alpha1)
Provides:       bundled golang(github.com/cucumber/godog)
Provides:       bundled golang(github.com/cucumber/messages-go/v10)
Provides:       bundled golang(github.com/jenkins-x/go-scm/scm)
Provides:       bundled golang(github.com/jenkins-x/go-scm/scm/factory)
Provides:       bundled golang(github.com/mitchellh/go-homedir)
Provides:       bundled golang(github.com/mkmik/multierror)
Provides:       bundled golang(github.com/openshift/api/route/v1)
Provides:       bundled golang(github.com/openshift/client-go/route/clientset/versioned/scheme)
Provides:       bundled golang(github.com/openshift/client-go/route/clientset/versioned/typed/route/v1)
Provides:       bundled golang(github.com/openshift/odo/pkg/log)
Provides:       bundled golang(github.com/operator-framework/operator-lifecycle-manager/pkg/api/client/clientset/versioned/typed/operators/v1alpha1)
Provides:       bundled golang(github.com/pkg/errors)
Provides:       bundled golang(github.com/spf13/afero)
Provides:       bundled golang(github.com/spf13/cobra)
Provides:       bundled golang(github.com/spf13/cobra/doc)
Provides:       bundled golang(github.com/tektoncd/pipeline/pkg/apis/pipeline/v1alpha1)
Provides:       bundled golang(github.com/tektoncd/pipeline/pkg/apis/pipeline/v1beta1)
Provides:       bundled golang(github.com/tektoncd/triggers/pkg/apis/triggers/v1alpha1)
Provides:       bundled golang(github.com/zalando/go-keyring)
Provides:       bundled golang(gopkg.in/AlecAivazis/survey.v1)
Provides:       bundled golang(gopkg.in/AlecAivazis/survey.v1/terminal)
Provides:       bundled golang(k8s.io/api/apps/v1)
Provides:       bundled golang(k8s.io/api/core/v1)
Provides:       bundled golang(k8s.io/apimachinery/pkg/api/errors)
Provides:       bundled golang(k8s.io/apimachinery/pkg/api/resource)
Provides:       bundled golang(k8s.io/apimachinery/pkg/apis/meta/v1)
Provides:       bundled golang(k8s.io/apimachinery/pkg/api/validation)
Provides:       bundled golang(k8s.io/apimachinery/pkg/runtime)
Provides:       bundled golang(k8s.io/apimachinery/pkg/runtime/schema)
Provides:       bundled golang(k8s.io/apimachinery/pkg/types)
Provides:       bundled golang(k8s.io/apimachinery/pkg/util/intstr)
Provides:       bundled golang(k8s.io/apimachinery/pkg/util/validation)
Provides:       bundled golang(k8s.io/apimachinery/pkg/watch)
Provides:       bundled golang(k8s.io/api/rbac/v1)
Provides:       bundled golang(k8s.io/client-go/kubernetes)
Provides:       bundled golang(k8s.io/client-go/kubernetes/typed/core/v1)
Provides:       bundled golang(k8s.io/client-go/rest)
Provides:       bundled golang(k8s.io/client-go/tools/clientcmd)
Provides:       bundled golang(k8s.io/client-go/util/cert)
Provides:       bundled golang(k8s.io/klog)
Provides:       bundled golang(k8s.io/kubectl/pkg/util/templates)
Provides:       bundled golang(knative.dev/pkg/apis)
Provides:       bundled golang(sigs.k8s.io/yaml)

%description redistributable
%{summary}

%prep
%setup -q -n %{source_dir}
mkdir -p %{_builddir}/src

%global make GOPATH=%{_builddir} make -e GOFLAGS="-mod=vendor" VERSION="v%{kam_version}-%{commitid}" 

%build
%{make} all_platforms

%install
install -d %{buildroot}%{_bindir}
install -p -m 0755 dist/kam_linux_$(go env GOHOSTARCH) %{buildroot}%{_bindir}/kam
%ifarch x86_64
install -d %{buildroot}%{_datadir}/%{name}-redistributable/{linux,macos,windows}
install -p -m 0755 dist/kam_linux_amd64 %{buildroot}%{_datadir}/%{name}-redistributable/linux/kam-linux-amd64
install -p -m 0755 dist/kam_linux_arm64 %{buildroot}%{_datadir}/%{name}-redistributable/linux/kam-linux-arm64
install -p -m 0755 dist/kam_linux_ppc64le %{buildroot}%{_datadir}/%{name}-redistributable/linux/kam-linux-ppc64le
install -p -m 0755 dist/kam_linux_s390x %{buildroot}%{_datadir}/%{name}-redistributable/linux/kam-linux-s390x
install -p -m 0755 dist/kam_darwin_amd64 %{buildroot}%{_datadir}/%{name}-redistributable/macos/kam-darwin-amd64
install -p -m 0755 dist/kam_darwin_arm64 %{buildroot}%{_datadir}/%{name}-redistributable/macos/kam-darwin-arm64
install -p -m 0755 dist/kam_windows_amd64.exe %{buildroot}%{_datadir}/%{name}-redistributable/windows/kam-windows-amd64.exe
install -p -m 0755 dist/kam_windows_arm64.exe %{buildroot}%{_datadir}/%{name}-redistributable/windows/kam-windows-arm64.exe
%endif

%files
%license LICENSE
%{_bindir}/kam

%ifarch x86_64
%files redistributable
%license LICENSE
%dir %{_datadir}/%{name}-redistributable/linux/
%dir %{_datadir}/%{name}-redistributable/macos/
%dir %{_datadir}/%{name}-redistributable/windows/
%{_datadir}/%{name}-redistributable/linux/kam-linux-amd64
%{_datadir}/%{name}-redistributable/linux/kam-linux-arm64
%{_datadir}/%{name}-redistributable/linux/kam-linux-ppc64le
%{_datadir}/%{name}-redistributable/linux/kam-linux-s390x
%{_datadir}/%{name}-redistributable/macos/kam-darwin-amd64
%{_datadir}/%{name}-redistributable/macos/kam-darwin-arm64
%{_datadir}/%{name}-redistributable/windows/kam-windows-amd64.exe
%{_datadir}/%{name}-redistributable/windows/kam-windows-arm64.exe
%endif

%changelog
